#!/usr/bin/perl
# 
# library - html 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.13;
	# ver 0.00 [2003/09/20] 
	# ver 0.01 [2003/10/07] sbhtml_head ǥСԤξ褦 / С褦
	# ver 0.02 [2003/10/27] إåɽեåɽ body Ǥޤޤʤ褦
	# ver 0.03 [2003/10/30] DOCTYPE ѹ
	# ver 0.04 [2003/10/30] 쥯Ȥ㴳ѹ
	# ver 0.05 [2003/11/08] sbhtml_gethost ɲ
	# ver 0.06 [2003/11/13] sbhtml_http ˥åإåɲäǤ褦
	# ver 0.07 [2003/11/21] 饤֥ sbtime.pl  require
	# ver 0.08 [2004/05/03] <head>Ϥ㴳
	# ver 0.09 [2004/05/19] sbhtml_cookie ɲ
	# ver 0.10 [2004/06/10] sbhtml_http  Location ưѹ
	# ver 0.11 [2004/07/02] sbhtml_cookie 
	# ver 0.12 [2004/07/28] sbhtml_cookie 
	# ver 0.13 [2004/11/26] sbhtml_cookie (ΥåȯԤХ)
	require 'sbtime.pl';
	require 'sbtext.pl';
}

sub sbhtml_http { # HTTPإå
	my ($cookie,$url,$charset,$cache) = @_; # ϥѥ᡼ / å,ƤӽФ,饻å,å /
	my ($out);                              # ϥѥ᡼
	$out .= 'Set-Cookie: ' . $cookie . "\n" if ($cookie ne '');
	if ($url ne '') {
		my ($hash,$query) = ();
		($url,$hash)  = split('\#',$url,2) if (index($url,'#') > -1);
		($url,$query) = split('\?',$url,2) if (index($url,'?') > -1);
		$url .= '?' . $query;
		$url .= '#' . $hash if ($hash ne '');
		$out .= 'Location: ' . $url . "\n";
	} else {
		$out .= 'Content-Type: text/html;';
		$out .= ($charset eq '') ? "\n" : ' charset=' . $charset . ';' . "\n";
		if ($cache eq 'nocache') {
			$out .= 'Pragma: no-cache' . "\n";
			$out .= 'Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0' . "\n";
			$out .= 'Expires: ' . &sbtime_stamp($gNowTime - 100,'%wk, %Dy-%MO-%yr %hr:%mi:%sc GMT','+0000','en') . "\n";
		}
	}
	$out .= "\n"; # إåȥܥǥζڤ
	return($out);
}

sub sbhtml_gethost { # 
	my ($host,$addr,$refe,$agnt) = (); # ϥѥ᡼
	$refe = $ENV{'HTTP_REFERER'};
	$host = $ENV{'REMOTE_HOST'};
	$addr = $ENV{'REMOTE_ADDR'};
	$agnt = $ENV{'HTTP_USER_AGENT'};
	$host = $addr if ($host eq '');
	$host = gethostbyaddr(pack('C4',split(/\./,$host)),2) || $addr if ($host eq $addr);
	return($host,$addr,$refe,$agnt);
}

sub sbhtml_head { # HTMLإå
	my ($type,$lang,$char,$style,$script,$mail,$title,$ln_val,$mt_val) = @_; # ϥѥ᡼
	my ($html) = ();                                                         # ϥѥ᡼
	my %ln = %$ln_val;
	my %mt = %$mt_val;
	my $tail = ($type eq 'xhtml') ? ' />' . "\n" : '>' . "\n";
	if ($type eq 'xhtml') {
		$html .= '<?xml version="1.0" encoding="' . $char . '"?>' . "\n";
		$html .= '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">' . "\n";
		$html .= '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="' . $lang . '">' . "\n";
	} else {
		$html .= '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">' . "\n";
		$html .= '<html lang="' . $lang . '">' . "\n";
	}
	$html .= '<head>' . "\n";
	$html .= '<meta http-equiv="Content-Type" content="text/html; charset=' . $char . '"' . $tail;
	$html .= '<meta http-equiv="Content-Style-Type" content="text/css"' . $tail if ($style ne '');
	$html .= '<meta http-equiv="Content-Script-Type" content="text/javascript"' . $tail if ($script ne '');
	while (my ($name,$val) = each(%mt)) {
		$html .= '<meta http-equiv="' . $name . '" content="' . $val . '"' . $tail;
	}
	$html .= '<meta name="version" content="' . $gVersion_ . '"' . $tail;
	$html .= '<link rel="author" href="mailto:' . $mail . '"' . $tail if ($mail ne '');
	while (my ($name,$val) = each(%ln)) {
		$html .= '<link rel="' . $name . '" href="' . $val . '"' . $tail;
	}
	if ($style ne '') { # 륷Ȼ
		my ($uri,$name) = split(',',$style,2); $name = 'default' if ($name eq '');
		$html .= '<link rel="stylesheet" href="' . $uri . '" type="text/css" media="screen,tv" title="' . $name . '"' . $tail;
	}
	if ($script ne '') { # Javascript 
		my ($src,$set) = split(',',$script,2);
		$html .= '<script type="text/javascript" src="' . $src . '"';
		$html .= ' charset="' . $set . '"' if ($set ne '');
		$html .= '></script>' . "\n";
	}
	$html .= '<title>' . $title . '</title>' . "\n";
	$html .= '</head>' . "\n";
	return($html);
}
sub sbhtml_cookie { # å
	my ($name,$expire,$mode,$path) = @_;        # ϥѥ᡼ / ̾, ͭ(), ⡼( $gEnv ¸ )
	my $output = '';                            # ϥѥ᡼
	my ($cookie,$date,$cook_path,%eating) = (); # ѥ᡼
	{ # ạ̊
		$date = $gNowTime + ($expire * 3600);
		$date = &sbtime_stamp($date,'%wk, %Dy-%MO-%yr %hr:%mi:%sc GMT','+0000','en')
	}
	{ # å٤
		my (@cookies,%cookie_base);
		@cookies = split(/;/,$ENV{'HTTP_COOKIE'});
		foreach (@cookies) {
			my ($cook_key,$cook_val) = split(/=/,$_);
			$cook_key =~ s/ //g;
			$cookie_base{$cook_key} = $cook_val;
		}
		@cookies = split(/,/,$cookie_base{$name});
		foreach (@cookies) {
			my ($cook_key,$cook_val) = split('<>',$_);
			$cook_val = &sbtxt_uridec_utf8($cook_val,$gEnv{'code'});
			$eating{$cook_key} = $cook_val;
		}
	}
	if ($mode ne '') { # å򤷤ޤ
		foreach my $key ( @{$gEnv{$mode}{'cookie'}} ) {
			$gIn{$key} = $eating{$key} if (($gIn{$key} eq '' and $key ne 'checkid') or $key eq 'checkid');
			my $val = &sbtxt_urienc_utf8($gIn{$key},$gEnv{'code'});
			$val = $gEnv{'global'}{'spamid'} if ($key eq 'checkid');
			$cookie .= $key . '<>' . $val . ',' if ($val ne '');
		}
	} else {
		$cookie = $name . '<>on,';
	}
	if ($path ne '' and $path =~ /http:\/\/(.*?)\/(.*)\//) {
		$cook_path = ' domain=' . $1 . '; path=/' . $2 . ';';
	} else {
		$cook_path = '';
	}
	$output = "$name=$cookie; expires=$date;$cook_path" if ($cookie ne '');
	return($output);
}

sub sbhtml_foot { # HTMLեå
	my ($text,$ver) = @_; # ϥѥ᡼
	my ($html) = ();      # ϥѥ᡼
	$html .= $text . "\n" if ($text ne '');
	$html .= '<!-- scripted by SimpleBoxes [ver.' . $ver . '] -->' . "\n";
	$html .= '</html>' . "\n";
	return($html);
}
1;
